using System;
using System.ComponentModel;
using System.Reflection;

namespace SystemNeo.ComponentModel
{
	/// <summary>
	/// 
	/// </summary>
	public static class ComponentUtil
	{
		// public static \bh //

		/// <summary>
		/// vpeB̃ftHgl擾܂B
		/// </summary>
		/// <param name="targetType"></param>
		/// <param name="propertyName"></param>
		/// <returns></returns>
		public static object GetPropertyDefaultValue(Type targetType, string propertyName)
		{
			PropertyInfo property = targetType.GetProperty(propertyName);
			if (property == null) {
				return DBNull.Value;
			}
			return GetPropertyDefaultValue(property);
		}

		/// <summary>
		/// vpeB̃ftHgl擾܂B
		/// </summary>
		/// <param name="property"></param>
		/// <returns></returns>
		public static object GetPropertyDefaultValue(PropertyInfo property)
		{
			object[] attributes = property.GetCustomAttributes(typeof(DefaultValueAttribute), false);
			if (attributes.Length == 1) {
				return ((DefaultValueAttribute)attributes[0]).Value;
			} else {
				return DBNull.Value;
			}
		}

		/// <summary>
		/// w肵IuWFNg̃vpeB̒l
		/// ̃vpeB̃ftHglƓǂ𒲂ׂ܂B
		/// </summary>
		/// <param name="property"></param>
		/// <param name="target"></param>
		/// <returns>vpeB̒lftHglƓ trueB</returns>
		public static bool PropertyHasDefaultValue(PropertyInfo property, object target)
		{
			object defaultValue = GetPropertyDefaultValue(property);
			if (defaultValue is DBNull) {
				return false;
			}
			object value = property.GetValue(target, new object[] {});
			return object.Equals(value, defaultValue);
		}
	}
}
